{                            FUNKTIOT.PAS
  Tiedostossa mritellyt aliohjelmat:

  LaskeFunktio(...);
    Pop(...);
    Push(...);
    LaskePlus(...);
    LaskeMinus(...);
    LaskeUMinus(...);
    LaskeDivi(...);
    LaskePot(...);
    LaskeMul(...);
    LaskeSini(...);
    LaskeCosi(...);
    LaskeTani(...);
    LaskeExpi(...),
    LaskeLni(...);
    LaskeSqrti(...);
    LaskeAbsi(...);
    Laske(ArcTani(...);
    VakioPinoon(...);
    MuuttujaPinoon(...);
}
{ Aliohjelmalla lasketaan Jono:ssa olevan RPN-lausekkeen arvo. Virhetarkas-
  teluja ei tarvitse tehd, sill Jono:a muodostettaessa on huolehdittu
  syntaksitarkastuksesta. Tarvittaessa aliohjelmaa voi nopeuttaa huomattavasti
  vhentmll pino-operaatioita (Popataan vain toinen parametri pinosta
  ja kytetn pinon huippua toisena parametrina tai yhden parametrin
  funktioissa laskea suoraan pinono huipun avulla. Toinen vaihtoehto on
  esitt pino taulukkona, jolloin dynaamisten muuttujien hidasta luontia/
  poistoa ei tarvita).

  Korjattavaa:
   - nopeutus   (?)
   - complex -funktiot
}

Procedure LaskeFunktio(Jono : FunktioJono;  { RPN-lauseke }
                       Var Tulos : Luku);   { Lausekkeesta saatu tulos }

Type  Pino = ^Stack;           { RPN:ss kytettv pino }
      Stack = Record
                Arvo : Luku;
                Alas : Pino;
              End; { Stack }

Var   Top : Pino;


  { Aliohjelmalla palautetaan pinon plimmisen alkion arvo ja poistetaan
    kyseinen alkio pinosta.
  }
  Procedure Pop(Var Top : Pino; Var Popsis : Luku);
  Var  Poistettava : Pino;
  Begin
    Popsis:=Top^.Arvo;
    Poistettava:=Top;
    Top:=Top^.Alas;
    Dispose(Poistettava);
  End;  { Pop }

  { Aliohjelma tynt pinoon Pinoon -muuttujan arvon. Tss, kuten mys
  edellisess aliohjelmassa tehdn todelliset dynaamisenmuistin varaukset/
  vapautukset.
  }
  Procedure Push(Var Top : Pino; Var Pinoon : Luku);
  Var  Lisattava : Pino;
  Begin
    New(Lisattava);
    Lisattava^.Arvo:=Pinoon;
    Lisattava^.Alas:=Top;
    Top:=Lisattava;
  End; { Push }


{=============================================================================
  Seuraavassa on kaikki funktiot, jotka ohjelma ymmrt. Niit ei ole en-
  simmist lukuunottamatta kommentoitu, koska ne kaikki toimivat vastaavasti
  kuin ensimminen funktio (LaskePlus):

  Kaikissa funktioissa tulos palautetaan pinon plimmiseksi!
}

{ Lasketaan kaksi pinossa olevaa reaalilukua yhteen
}
  Procedure LaskePlus(Var Huippu : Pino); { Parametrina pinon huipun osoitin }
  Var   x,             { x ja y ovat summan yhteenlaskettavia. }
        y,
        Summa : Luku;  { Summa on tulos, joka palautetaan pinoon. }
  Begin
    Pop(Huippu,y);               { Otetaan pinon plimminen luku y:n.   }
    Pop(Huippu,x);               { Otetaan pinon plimminen luku x:n.  }
    Summa.Tyyppi:=Reali;         { Tm on reaalifunktio.                 }
    Summa.Arvo:=x.Arvo + y.Arvo; { Varsinainen laskutoimitus.             }
    Push(Huippu,Summa);          { Laitetaan vastau pinon plimmiseksi. }
  End; { Laske Plus }

{ Vhennetn pinon toiseksi ylimmst luvusta pinon plimminen liku
}
  Procedure LaskeMinus(Var Huippu : Pino);
  Var   x,y,Erotus : Luku;
  Begin
    Pop(Huippu,y);
    Pop(Huippu,x);
    Erotus.Tyyppi:=Reali;
    Erotus.Arvo:=x.Arvo - y.Arvo;
    Push(Huippu,Erotus);
  End; { LaskeMinus }

{ Vaihdetaan pinon plimmisen luvun etumerkki
}
  Procedure LaskeUMinus(Var Huippu : Pino);
  Var  x : Luku;
  Begin
    Pop(Huippu,x);
    x.Arvo:= - x.Arvo;
    Push(Huippu,x);
  End; { LaskeUMinus  }

{ Jaetaan pinon toiseksi ylin luku pinon plimmisell
}
  Procedure LaskeDivi(Var Huippu : Pino);
  Var  x,y,Jako : Luku;
  Begin
    Pop(Huippu,y);
    Pop(Huippu,x);
    Jako.Tyyppi:=Reali;
    Jako.Arvo:=x.Arvo/y.Arvo;
    Push(Huippu,Jako);
  End;  { LaskeDivi }

{ Korotetaan pinon toiseksi ylin luku ylimmn osoittamaan potenssiin.
  kantaluvun pit olla aidosti positiivinen.
}
  Procedure LaskePot(Var Huippu : Pino);
  Var   x,y,Power : Luku;
  Begin
    Pop(Huippu,y);
    Pop(Huippu,x);
    Power.Tyyppi:=Reali;
    Power.Arvo:=Exp(y.Arvo*Ln(x.Arvo));
    Push(Huippu,Power);
  End; { LaskePot }

{ Kerrotaan pinon plimmiset luvut keskenn
}
  Procedure LaskeMul(Var Huippu : Pino);
  Var  x,y,Kerto : Luku;
  Begin
    Pop(Huippu,y);
    Pop(Huippu,x);
    Kerto.Tyyppi:=Reali;
    Kerto.Arvo:=x.Arvo * y.Arvo;
    Push(Huippu,Kerto);
  End; { LaskeMul }

{ Laskeen pinon plimmisen luvun sinin
}
  Procedure LaskeSini(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Sin(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeSin }

{ Laskee pinon plimmisen luvun cosinin
}
  Procedure LaskeCosi(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Cos(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeSin }

{ Laskee pinon plimmisen lukun tangentin
}
  Procedure LaskeTani(Var Huippu : Pino);
  Var  x,Tulos : Luku;
    Function Tan(x : Real) : Real;
    Begin
      Tan:=Sin(x)/Cos(x);
    End; { Tan }
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Tan(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeTan }

{ Korottaa e:n pinon plimmisen luvun potenssiin
}
  Procedure LaskeExpi(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Exp(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeExp }

{ Laskee pinon plimmisen luvun logaritmin
}
  Procedure LaskeLni(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Ln(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeLn }

{ Laskee pinon plimmisen luvun nelin
}
  Procedure LaskeSqri(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Sqr(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeSqri }

{ Laskee pinon plimmisen luvun nelijuuren
}
  Procedure LaskeSqrti(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Sqrt(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeSqrti }

{ Ottaa pinon plimmisen luvun itseisarvon
}
  Procedure LaskeAbsi(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Abs(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeAbsi }

{ Laskee pinon plimmisen luvun arcus tangentin
}
  Procedure LaskeArctani(Var Huippu : Pino);
  Var  x,Tulos : Luku;
  Begin
    Pop(Huippu,x);
    Tulos.Tyyppi:=Reali;
    Tulos.Arvo:=Arctan(x.Arvo);
    Push(Huippu,Tulos);
  End; { LaskeArctani
==============================================================================}

  { Aliohjelma laittaa parametrina annetun vakion pinoon.
  }
  Procedure VakioPinoon(Var Huippu : Pino; x : Luku);
  Begin
    Push(Huippu,x);
  End; { Vakio Pinoon }

  { Aliohjelma laittaa parametrin os osoittaman muuttujan pinoon.
  }
  Procedure MuuttujaPinoon(Var Huippu : Pino; os : VakioIndex);
  Var  x : Luku;
  Begin
    x:=VakioArvot[os].Arvo;
    Push(Huippu,x);
  End; { Muuttuja Pinoon }

{ Varsinainen laskentarutiini. Aliohjelma ky silmukassa lpi koko
  dynaamisen listan ja listen alkion perustella haarautuu Case-
  lauseessa tarvittavaan aliohjelmakutsuun. Lopuksi asetettaan
  muuttujaan Tulos pinon huipun arvo.
}
Begin { LaskeFunktio }
  While Jono^.Seuraava <> Nil Do Begin
    Case Jono^.Alkio Of
      Muuttuja : MuuttujaPinoon(Top,Jono^.Osoitin);
      Vakio    : VakioPinoon(Top,Jono^.Arvo);
      Plus     : LaskePlus(Top);
      Minus    : LaskeMinus(Top);
      UMinus   : LaskeUMinus(Top);
      Divi     : LaskeDivi(Top);
      Pot      : LaskePot(Top);
      Mul      : LaskeMul(Top);
      Sini     : LaskeSini(Top);
      Cosi     : LaskeCosi(Top);
      Tani     : LaskeTani(Top);
      Expi     : LaskeExpi(Top);
      Lni      : LaskeLni(Top);
      Sqri     : LaskeSqri(Top);
      Sqrti    : LaskeSqrti(Top);
      Absi     : LaskeAbsi(Top);
      Arctani  : LaskeArctani(Top);
      Else Begin
        WriteLn('"This can''t happen!"');
        WriteLn('... Procedure LaskeFunktio');
        Halt(1);
      End;
    End; { Case }
    Jono:=Jono^.Seuraava;
  End; { While -silmukka }
  Pop(Top, Tulos);
End; { Laske Funktio }

